<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/standard/packageWriter.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/packagewriter.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/standard/packageWriter.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** This generates the package-summary.html files that list the interfaces and
<a name="line22"></a> * classes for a given package.
<a name="line23"></a> *
<a name="line24"></a> * @package PHPDoctor\Doclets\Standard
<a name="line25"></a> */
<a name="line26"></a>class PackageWriter extends HTMLWriter
<a name="line27"></a>{
<a name="line28"></a>
<a name="line29"></a>	/** Build the package summaries.
<a name="line30"></a>	 *
<a name="line31"></a>	 * @param Doclet doclet
<a name="line32"></a>	 */
<a name="line33"></a>	function packageWriter(&$doclet)
<a name="line34"></a>    {
<a name="line35"></a>	
<a name="line36"></a>		parent::HTMLWriter($doclet);
<a name="line37"></a>        
<a name="line38"></a>		$rootDoc =& $this->_doclet->rootDoc();
<a name="line39"></a>		$phpdoctor =& $this->_doclet->phpdoctor();
<a name="line40"></a>		
<a name="line41"></a>		$displayTree = $phpdoctor->getOption('tree');
<a name="line42"></a>		
<a name="line43"></a>		if ($displayTree) {
<a name="line44"></a>			$this->_sections[0] = array('title' => 'Overview', 'url' => 'overview-summary.html');
<a name="line45"></a>			$this->_sections[1] = array('title' => 'Namespace');
<a name="line46"></a>			$this->_sections[2] = array('title' => 'Class');
<a name="line47"></a>			//$this->_sections[3] = array('title' => 'Use');
<a name="line48"></a>			$this->_sections[4] = array('title' => 'Tree', 'selected' => TRUE);
<a name="line49"></a>			if ($doclet->includeSource()) $this->_sections[5] = array('title' => 'Files', 'url' => 'overview-files.html');
<a name="line50"></a>			$this->_sections[6] = array('title' => 'Deprecated', 'url' => 'deprecated-list.html');
<a name="line51"></a>			$this->_sections[7] = array('title' => 'Todo', 'url' => 'todo-list.html');
<a name="line52"></a>			$this->_sections[8] = array('title' => 'Index', 'url' => 'index-all.html');
<a name="line53"></a>
<a name="line54"></a>            $this->_id = 'tree';
<a name="line55"></a>            
<a name="line56"></a>			$tree = array();
<a name="line57"></a>			$classes =& $rootDoc->classes();
<a name="line58"></a>			if ($classes) {
<a name="line59"></a>				foreach ($classes as $class) {
<a name="line60"></a>					$this->_buildTree($tree, $class);
<a name="line61"></a>				}
<a name="line62"></a>			}
<a name="line63"></a>
<a name="line64"></a>			ob_start();
<a name="line65"></a>			
<a name="line66"></a>			echo "<hr>\n\n";
<a name="line67"></a>			echo '<h1>Class Hierarchy</h1>';
<a name="line68"></a>			
<a name="line69"></a>			$this->_displayTree($tree);
<a name="line70"></a>
<a name="line71"></a>			$this->_output = ob_get_contents();
<a name="line72"></a>			ob_end_clean();
<a name="line73"></a>
<a name="line74"></a>			$this->_write('overview-tree.html', 'Overview', TRUE);
<a name="line75"></a>		}
<a name="line76"></a>        
<a name="line77"></a>        $this->_id = 'package';
<a name="line78"></a>
<a name="line79"></a>        $packages =& $rootDoc->packages();
<a name="line80"></a>        ksort($packages);
<a name="line81"></a>        
<a name="line82"></a>		foreach($packages as $packageName => $package) {
<a name="line83"></a>		
<a name="line84"></a>			$this->_depth = $package->depth() + 1;
<a name="line85"></a>
<a name="line86"></a>			$this->_sections[0] = array('title' => 'Overview', 'url' => 'overview-summary.html');
<a name="line87"></a>			$this->_sections[1] = array('title' => 'Namespace', 'selected' => TRUE);
<a name="line88"></a>			$this->_sections[2] = array('title' => 'Class');
<a name="line89"></a>			//$this->_sections[3] = array('title' => 'Use');
<a name="line90"></a>			if ($displayTree) $this->_sections[4] = array('title' => 'Tree', 'url' => $package->asPath().'/package-tree.html');
<a name="line91"></a>			if ($doclet->includeSource()) $this->_sections[5] = array('title' => 'Files', 'url' => 'overview-files.html');
<a name="line92"></a>			$this->_sections[6] = array('title' => 'Deprecated', 'url' => 'deprecated-list.html');
<a name="line93"></a>			$this->_sections[7] = array('title' => 'Todo', 'url' => 'todo-list.html');
<a name="line94"></a>			$this->_sections[8] = array('title' => 'Index', 'url' => 'index-all.html');
<a name="line95"></a>            
<a name="line96"></a>			ob_start();
<a name="line97"></a>			
<a name="line98"></a>			echo "<hr>\n\n";
<a name="line99"></a>		
<a name="line100"></a>			echo '<h1>Namespace ', $package->name(), "</h1>\n\n";
<a name="line101"></a>
<a name="line102"></a>			$textTag =& $package->tags('@text');
<a name="line103"></a>			if ($textTag) {
<a name="line104"></a>				echo '<div class="comment">', $this->_processInlineTags($textTag, TRUE), "</div>\n\n";
<a name="line105"></a>				echo '<dl><dt>See:</dt><dd><b><a href="#overview_description">Description</a></b></dd></dl>', "\n\n";
<a name="line106"></a>			}
<a name="line107"></a>
<a name="line108"></a>			$classes =& $package->ordinaryClasses();
<a name="line109"></a>			if ($classes) {
<a name="line110"></a>                ksort($classes);
<a name="line111"></a>				echo '<table class="title">', "\n";
<a name="line112"></a>				echo '<tr><th colspan="2" class="title">Class Summary</th></tr>', "\n";
<a name="line113"></a>				foreach($classes as $name => $class) {
<a name="line114"></a>					$textTag =& $classes[$name]->tags('@text');
<a name="line115"></a>					echo '<tr><td class="name"><a href="', str_repeat('../', $this->_depth), $classes[$name]->asPath(), '">', $classes[$name]->name(), '</a></td>';
<a name="line116"></a>					echo '<td class="description">';
<a name="line117"></a>					if ($textTag) echo strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>');
<a name="line118"></a>					echo "</td></tr>\n";
<a name="line119"></a>				}
<a name="line120"></a>				echo "</table>\n\n";
<a name="line121"></a>			}
<a name="line122"></a>
<a name="line123"></a>			$interfaces =& $package->interfaces();
<a name="line124"></a>			if ($interfaces) {
<a name="line125"></a>                ksort($interfaces);
<a name="line126"></a>				echo '<table class="title">'."\n";
<a name="line127"></a>				echo '<tr><th colspan="2" class="title">Interface Summary</th></tr>'."\n";
<a name="line128"></a>				foreach($interfaces as $name => $interface) {
<a name="line129"></a>					$textTag =& $interfaces[$name]->tags('@text');
<a name="line130"></a>					echo '<tr><td class="name"><a href="', str_repeat('../', $this->_depth), $interfaces[$name]->asPath(), '">', $interfaces[$name]->name(), '</a></td>';
<a name="line131"></a>					echo '<td class="description">';
<a name="line132"></a>					if ($textTag) echo strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>');
<a name="line133"></a>					echo "</td></tr>\n";
<a name="line134"></a>				}
<a name="line135"></a>				echo "</table>\n\n";
<a name="line136"></a>			}
<a name="line137"></a>
<a name="line138"></a>			$exceptions =& $package->exceptions();
<a name="line139"></a>			if ($exceptions) {
<a name="line140"></a>                ksort($exceptions);
<a name="line141"></a>				echo '<table class="title">'."\n";
<a name="line142"></a>				echo '<tr><th colspan="2" class="title">Exception Summary</th></tr>'."\n";
<a name="line143"></a>				foreach($exceptions as $name => $exception) {
<a name="line144"></a>					$textTag =& $exceptions[$name]->tags('@text');
<a name="line145"></a>					echo '<tr><td class="name"><a href="', str_repeat('../', $this->_depth), $exceptions[$name]->asPath(), '">', $exceptions[$name]->name(), '</a></td>';
<a name="line146"></a>					echo '<td class="description">';
<a name="line147"></a>					if ($textTag) echo strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>');
<a name="line148"></a>					echo "</td></tr>\n";
<a name="line149"></a>				}
<a name="line150"></a>				echo "</table>\n\n";
<a name="line151"></a>			}
<a name="line152"></a>			
<a name="line153"></a>			$functions =& $package->functions();
<a name="line154"></a>			if ($functions) {
<a name="line155"></a>                ksort($functions);
<a name="line156"></a>				echo '<table class="title">', "\n";
<a name="line157"></a>				echo '<tr><th colspan="2" class="title">Function Summary</th></tr>', "\n";
<a name="line158"></a>				foreach($functions as $name => $function) {
<a name="line159"></a>					$textTag =& $functions[$name]->tags('@text');
<a name="line160"></a>					echo '<tr><td class="name"><a href="package-functions.html#', $functions[$name]->name(), '">', $functions[$name]->name(), '</a></td>';
<a name="line161"></a>					echo '<td class="description">';
<a name="line162"></a>					if ($textTag) echo strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>');
<a name="line163"></a>					echo "</td></tr>\n";
<a name="line164"></a>				}
<a name="line165"></a>				echo "</table>\n\n";
<a name="line166"></a>			}
<a name="line167"></a>			
<a name="line168"></a>			$globals =& $package->globals();
<a name="line169"></a>			if ($globals) {
<a name="line170"></a>                ksort($globals);
<a name="line171"></a>				echo '<table class="title">', "\n";
<a name="line172"></a>				echo '<tr><th colspan="2" class="title">Global Summary</th></tr>', "\n";
<a name="line173"></a>				foreach($globals as $name => $global) {
<a name="line174"></a>					$textTag =& $globals[$name]->tags('@text');
<a name="line175"></a>					echo '<tr><td class="name"><a href="package-globals.html#', $globals[$name]->name(), '">', $globals[$name]->name(), '</a></td>';
<a name="line176"></a>					echo '<td class="description">';
<a name="line177"></a>					if ($textTag) echo strip_tags($this->_processInlineTags($textTag, TRUE), '<a><b><strong><u><em>');
<a name="line178"></a>					echo "</td></tr>\n";
<a name="line179"></a>				}
<a name="line180"></a>				echo "</table>\n\n";
<a name="line181"></a>			}
<a name="line182"></a>
<a name="line183"></a>			$textTag =& $package->tags('@text');
<a name="line184"></a>			if ($textTag) {
<a name="line185"></a>				echo '<h1>Namespace ', $package->name(), " Description</h1>\n\n";
<a name="line186"></a>				echo '<div class="comment" id="overview_description">'. $this->_processInlineTags($textTag), "</div>\n\n";
<a name="line187"></a>			}
<a name="line188"></a>			
<a name="line189"></a>			echo "<hr>\n\n";
<a name="line190"></a>
<a name="line191"></a>			$this->_output = ob_get_contents();
<a name="line192"></a>			ob_end_clean();
<a name="line193"></a>			
<a name="line194"></a>			$this->_write($package->asPath().'/package-summary.html', $package->name(), TRUE);
<a name="line195"></a>			
<a name="line196"></a>			if ($displayTree) {
<a name="line197"></a>			
<a name="line198"></a>				$this->_sections[0] = array('title' => 'Overview', 'url' => 'overview-summary.html');
<a name="line199"></a>				$this->_sections[1] = array('title' => 'Namespace', 'url' => $package->asPath().'/package-summary.html', 'relative' => TRUE);
<a name="line200"></a>				$this->_sections[2] = array('title' => 'Class');
<a name="line201"></a>				//$this->_sections[3] = array('title' => 'Use');
<a name="line202"></a>				$this->_sections[4] = array('title' => 'Tree', 'url' => $package->asPath().'/package-tree.html', 'selected' => TRUE, 'relative' => TRUE);
<a name="line203"></a>				if ($doclet->includeSource()) $this->_sections[5] = array('title' => 'Files', 'url' => 'overview-files.html');
<a name="line204"></a>                $this->_sections[6] = array('title' => 'Deprecated', 'url' => 'deprecated-list.html');
<a name="line205"></a>                $this->_sections[7] = array('title' => 'Todo', 'url' => 'todo-list.html');
<a name="line206"></a>                $this->_sections[8] = array('title' => 'Index', 'url' => 'index-all.html');
<a name="line207"></a>
<a name="line208"></a>                $this->_id = 'tree';
<a name="line209"></a>                
<a name="line210"></a>				$tree = array();
<a name="line211"></a>				$classes =& $package->ordinaryClasses();
<a name="line212"></a>				if ($classes) {
<a name="line213"></a>                    ksort($classes);
<a name="line214"></a>					foreach ($classes as $class) {
<a name="line215"></a>						$this->_buildTree($tree, $class);
<a name="line216"></a>					}
<a name="line217"></a>				}
<a name="line218"></a>
<a name="line219"></a>				ob_start();
<a name="line220"></a>				
<a name="line221"></a>                echo "<hr>\n\n";
<a name="line222"></a>                
<a name="line223"></a>				echo '<h1>Class Hierarchy for Package ', $package->name(),'</h1>';
<a name="line224"></a>
<a name="line225"></a>				$this->_displayTree($tree);
<a name="line226"></a>
<a name="line227"></a>				$this->_output = ob_get_contents();
<a name="line228"></a>				ob_end_clean();
<a name="line229"></a>
<a name="line230"></a>				$this->_write($package->asPath().'/package-tree.html', $package->name(), TRUE);
<a name="line231"></a>			}
<a name="line232"></a>			
<a name="line233"></a>		}
<a name="line234"></a>	
<a name="line235"></a>	}
<a name="line236"></a>	
<a name="line237"></a>	/**
<a name="line238"></a>	 * Build the class tree branch for the given element
<a name="line239"></a>	 *
<a name="line240"></a>	 * @param ClassDoc[] tree
<a name="line241"></a>	 * @param ClassDoc element
<a name="line242"></a>	 */
<a name="line243"></a>	function _buildTree(&$tree, &$element)
<a name="line244"></a>    {
<a name="line245"></a>		$tree[$element->name()] = $element;
<a name="line246"></a>		if ($element->superclass()) {
<a name="line247"></a>			$rootDoc =& $this->_doclet->rootDoc();
<a name="line248"></a>            $superclass =& $rootDoc->classNamed($element->superclass());
<a name="line249"></a>            if ($superclass) {
<a name="line250"></a>                $this->_buildTree($tree, $superclass);
<a name="line251"></a>            }
<a name="line252"></a>		}
<a name="line253"></a>	}
<a name="line254"></a>	
<a name="line255"></a>	/**
<a name="line256"></a>	 * Build the class tree branch for the given element
<a name="line257"></a>	 *
<a name="line258"></a>	 * @param ClassDoc[] tree
<a name="line259"></a>	 * @param str parent
<a name="line260"></a>	 */
<a name="line261"></a>	function _displayTree($tree, $parent = NULL)
<a name="line262"></a>    {
<a name="line263"></a>		$outputList = TRUE;
<a name="line264"></a>		foreach($tree as $name => $element) {
<a name="line265"></a>			if ($element->superclass() == $parent) {
<a name="line266"></a>				if ($outputList) echo "<ul>\n";
<a name="line267"></a>				echo '<li><a href="', str_repeat('../', $this->_depth), $element->asPath(), '">', $element->qualifiedName(), '</a>';
<a name="line268"></a>				$this->_displayTree($tree, $name);
<a name="line269"></a>				echo "</li>\n";
<a name="line270"></a>				$outputList = FALSE;
<a name="line271"></a>			}
<a name="line272"></a>		}
<a name="line273"></a>		if (!$outputList) echo "</ul>\n";
<a name="line274"></a>	}
<a name="line275"></a>
<a name="line276"></a>}
<a name="line277"></a>
<a name="line278"></a>?>
<a name="line279"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/packagewriter.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>